package com.franckbarbier.chain_of_responsibility;

class Paraplegia implements Disability {

    @Override
    public String attestation() {
        return "Paraplegia";
    }

    @Override
    public Equipment equipment() {
        return Equipment.Wheelchair;
    }
}

public class Chain_of_responsibility {

    public static void main(String[] args) {

//        Responsibility_link attestation = new Responsibility_link() {
//            @Override
//            public boolean run(final Disability disability, Responsibility_link... followers) {
//                return true;
//            }
//        };

        Responsibility_link attestation = (disability, chain_of_responsibility) -> {
            return disability.attestation().equals("Bla Bla Bla...")
                    ? false
                    : chain_of_responsibility.length == 0
                            ? true
                            // Performance issue (initial primitive array is copied without first element):
                            : chain_of_responsibility[0].run(disability, java.util.Arrays.copyOfRange(chain_of_responsibility, 1, chain_of_responsibility.length));
        };
        Responsibility_link equipment = (disability, chain_of_responsibility) -> {
            return disability.equipment() == Disability.Equipment.None
                    ? false
                    : chain_of_responsibility.length == 0
                            ? true
                            : chain_of_responsibility[0].run(disability, java.util.Arrays.copyOfRange(chain_of_responsibility, 1, chain_of_responsibility.length));
        };
        Responsibility_link escort = (disability, chain_of_responsibility) -> {
            return disability.escort() > 1 ? false
                    : chain_of_responsibility.length == 0
                            ? true
                            : chain_of_responsibility[0].run(disability, java.util.Arrays.copyOfRange(chain_of_responsibility, 1, chain_of_responsibility.length));
        };
        System.out.println("Event access? " + attestation.run(new Paraplegia(), equipment, escort));
    }
}
